//
//  SystemPhoto.m
//  ILoveCamera
//
//  Created by apple on 13-9-17.
//  Copyright (c) 2013年 Divein. All rights reserved.
//

#import "SystemPhoto.h"
#import <AssetsLibrary/AssetsLibrary.h>

@implementation SystemPhoto
{
    ALAssetsLibrary * _asserLibrary;

}

static SystemPhoto * instance = nil;

@synthesize albums = _albums;


-(void)dealloc
{
    [super dealloc];
    [_asserLibrary release];

    
}

/*
一个单例类在任何时候调用都是同一个对象，
 方法并不能保持数据的状态，所以数据的存储并传递，应该用变量（全局变量和局部变量，静态变量）。本次使用全局变量，因为所获得的
 数据，需要在视图控制器类中使用。
 
 也可以用消息机制，在事件完成后发送消息给接收者，并且附带数据，这样也可以实现两个类之间的数据传输。
 
 */


+(SystemPhoto*)defaultSystemPhoto{
    if (nil == instance) {
        instance = [[SystemPhoto alloc]init];
        return instance;
    }
    return instance;
}



-(void)loadData
{
//     __block NSMutableArray* albumCollector = [[NSMutableArray alloc] initWithCapacity:1];
    _asserLibrary = [[ALAssetsLibrary alloc]init];
       __block NSMutableArray* albumCollector = [[NSMutableArray alloc] initWithCapacity:1];
    //在系统相册全部枚举完了之后，还会继续枚举一次，这次的group 会变为nil，这里可以用来作为数据传递的入口。
    [_asserLibrary enumerateGroupsWithTypes:ALAssetsGroupAll usingBlock:^(ALAssetsGroup *group, BOOL *stop) {
        if (group==nil)
        {
            //这里为空，则发送消息出去，告诉消息接收者异步枚举相册已经完成，并且将获得的相册集合数据传过去。
            [[NSNotificationCenter defaultCenter]  postNotificationName:@"sentgroups" object:nil userInfo:[NSDictionary dictionaryWithObject:albumCollector forKey:@"album"]];
            _albums = [[NSMutableArray alloc] initWithArray:albumCollector];
            
            return ;
        }
        
        [albumCollector addObject:group];
        
       [group setAssetsFilter:[ALAssetsFilter allPhotos]];
        //result 是图片的一个  url和 类型 : (the result : ALAsset - Type:Photo, URLs:assets-library://asset/asset.JPG?id=987BED6E-CDB8-441E-8A1F-13D6632904BE&ext=JPG ) 
        [group enumerateAssetsUsingBlock:^(ALAsset *result, NSUInteger index, BOOL *stop) {
            if (result==nil) {
                return ;
            }
//            NSLog(@" the result  %@,",result);
        }];
        
    } failureBlock:^(NSError *error) {
        
        NSLog(@"there was an error with this App,the erroris : %@",error);
        
    }];
    
}







@end

























